var synchro = require('./index');

// same as s1 = synchro.create(async = false)
var s1 = synchro.create();

s1
  .add(function (step) {
    console.log('starting first step...');
    setTimeout(function () {
      console.log('first step DONE after 2 secs.');
      step.next();
    }, 2000);
  })
  .add(function (step) {
    console.log('starting second step...');
    setTimeout(function () {
      console.log('second step DONE after 3 secs.');
      step.next();
    }, 3000);
  })
  .add(function (step) {
    console.log('starting third step...');
    setTimeout(function () {
      console.log('third step DONE after 3 secs.');
      step.next();
    }, 3000);
  });


s1.on('done', function () {
  console.log('all steps executed in order!');
});

s1.run();

// same as s2 = synchro.create(async = true)
var s2 = synchro.create(true);

s2
  .add(function (step) {
    setTimeout(function () {
      step.next();
      console.log('callback 1 done...');
    }, Math.floor(Math.random() * 5000));
    console.log('waiting for callback 1...');
  })
  .add(function (step) {
    setTimeout(function () {
      console.log('callback 2 done...');
      step.next();
    }, Math.floor(Math.random() * 5000));
    console.log('waiting for callback 2...');
  })
  .add(function (step) {
    setTimeout(function () {
      console.log('callback 3 done...');
      step.next();
    }, Math.floor(Math.random() * 5000));
    console.log('waiting for callback 3...');
  });

s2.on('done', function () {
  console.log('all callbacks executed (may not be in order)!');
});

s2.run();
